## nodejs 20.18.3+dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python3
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
CLOUDFLARE_BUCKET ?= r2:dist-staging
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[:upper:]' '[:lower:]')
ifeq ($(findstring os/390,$OSTYPE),os/390)
OSTYPE ?= os390
endif
ARCHTYPE := $(shell uname -m | tr '[:upper:]' '[:lower:]')
COVTESTS ?= test-cov
COV_SKIP_TESTS ?= core_line_numbers.js,testFinalizer.js,test_function/test.js
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)
BUILD_WITH ?= make
FIND ?= find

ifdef JOBS
	PARALLEL_ARGS = -j $(JOBS)
else
	PARALLEL_ARGS =
endif

ifdef ENABLE_V8_TAP
	TAP_V8 := --junitout $(PWD)/v8-tap.xml
	TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
	TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
define convert_to_junit
	@true
endef
endif

ifdef ENABLE_CONVERT_V8_JSON_TO_XML
	TAP_V8_JSON := $(PWD)/v8-tap.json
	TAP_V8_INTL_JSON := $(PWD)/v8-intl-tap.json
	TAP_V8_BENCHMARKS_JSON := $(PWD)/v8-benchmarks-tap.json

	# By default, the V8's JSON test output only includes the tests which have
	# failed. We use --slow-tests-cutoff to ensure that all tests are present
	# in the output, including those which pass.
	TAP_V8 := --json-test-results $(TAP_V8_JSON) --slow-tests-cutoff 1000000
	TAP_V8_INTL := --json-test-results $(TAP_V8_INTL_JSON) --slow-tests-cutoff 1000000
	TAP_V8_BENCHMARKS := --json-test-results $(TAP_V8_BENCHMARKS_JSON) --slow-tests-cutoff 1000000

define convert_to_junit
	export PATH="$(NO_BIN_OVERRIDE_PATH)" && \
		$(PYTHON) tools/v8-json-to-junit.py < $(1) > $(1:.json=.xml)
endef
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
	V8_BUILD_OPTIONS += i18nsupport=off
endif
# V8 build and test toolchains are not currently compatible with Python 3.
# config.mk may have prepended a symlink for `python` to PATH which we need
# to undo before calling V8's tools.
OVERRIDE_BIN_DIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))out/tools/bin
NO_BIN_OVERRIDE_PATH=$(subst $() $(),:,$(filter-out $(OVERRIDE_BIN_DIR),$(subst :, ,$(PATH))))

ifeq ($(OSTYPE), darwin)
	GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[:upper:]' '[:lower:]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
# Use $(PWD) so we can cd to anywhere before calling this
NODE ?= "$(PWD)/$(NODE_EXE)"
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=full-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to quiet/pretty builds.
# To do verbose builds, run `make V=1` or set the V environment variable.
V ?= 0

# Use -e to double check in case it's a broken link
available-node = \
	if [ -x "$(NODE)" ] && [ -e "$(NODE)" ]; then \
		"$(NODE)" $(1); \
	elif [ -x `command -v node` ] && [ -e `command -v node` ] && [ `command -v node` ]; then \
		`command -v node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[[:alnum:]._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
ifeq ($(BUILD_WITH), make)
$(NODE_EXE): build_type:=Release
$(NODE_G_EXE): build_type:=Debug
$(NODE_EXE) $(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=${build_type} V=$(V)
	if [ ! -r $@ ] || [ ! -L $@ ]; then \
	  ln -fs out/${build_type}/$(NODE_EXE) $@; fi
else
ifeq ($(BUILD_WITH), ninja)
NINJA ?= ninja
ifeq ($(V),1)
	NINJA_ARGS := $(NINJA_ARGS) -v
endif
ifdef JOBS
	NINJA_ARGS := $(NINJA_ARGS) -j$(JOBS)
else
	IMMEDIATE_NINJA_ARGS := $(NINJA_ARGS)
	NINJA_ARGS = $(filter -j%,$(MAKEFLAGS))$(IMMEDIATE_NINJA_ARGS)
endif
$(NODE_EXE): config.gypi out/Release/build.ninja
	$(NINJA) -C out/Release $(NINJA_ARGS)
	if [ ! -r $@ ] || [ ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Debug/build.ninja
	$(NINJA) -C out/Debug $(NINJA_ARGS)
	if [ ! -r $@ ] || [ ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
$(NODE_EXE) $(NODE_G_EXE):
	$(warning This Makefile currently only supports building with 'make' or 'ninja')
endif
endif


ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif

.PHONY: with-code-cache
.PHONY: test-code-cache
with-code-cache test-code-cache:
	$(warning '$@' target is a noop)

out/Makefile: config.gypi common.gypi node.gyp \
	deps/uv/uv.gyp deps/llhttp/llhttp.gyp deps/zlib/zlib.gyp \
	deps/simdutf/simdutf.gyp deps/ada/ada.gyp \
	tools/v8_gypfiles/toolchain.gypi tools/v8_gypfiles/features.gypi \
	tools/v8_gypfiles/inspector.gypi tools/v8_gypfiles/v8.gyp
	$(PYTHON) tools/gyp_node.py -f make

# node_version.h is listed because the N-API version is taken from there
# and included in config.gypi
config.gypi: configure configure.py src/node_version.h
	@if [ -x config.status ]; then \
		export PATH="$(NO_BIN_OVERRIDE_PATH)" && ./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ --dest-dir '$(DESTDIR)' --prefix '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ --dest-dir '$(DESTDIR)' --prefix '$(PREFIX)'

.PHONY: clean
.NOTPARALLEL: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then $(FIND) out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	$(MAKE) testclean
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: testclean
.NOTPARALLEL: testclean
testclean:
# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*

.PHONY: distclean
.NOTPARALLEL: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
.NOTPARALLEL: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	$(RM) -r node_modules
	$(RM) -r gcovr
	$(RM) -r coverage/tmp
	@if [ -d "out/Release/obj.target" ]; then \
		$(FIND) out/$(BUILDTYPE)/obj.target \( -name "*.gcda" -o -name "*.gcno" \) \
			-type f | xargs $(RM); \
	fi

.PHONY: coverage
# Build and test with code coverage reporting. HTML coverage reports will be
# created under coverage/. For C++ coverage reporting, this needs to be run
# in conjunction with configure --coverage.
# Related CI job: node-test-commit-linux-coverage-daily
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	-$(MAKE) coverage-build-js
	if [ ! -d gcovr ]; then $(PYTHON) -m pip install -t gcovr gcovr==7.2; fi
	$(MAKE)

.PHONY: coverage-build-js
coverage-build-js:
	mkdir -p node_modules
	if [ ! -d node_modules/c8 ]; then \
		$(NODE) ./deps/npm install c8 --no-save --no-package-lock;\
	fi

.PHONY: coverage-test
coverage-test: coverage-build
	@if [ -d "out/Release/obj.target" ]; then \
		$(FIND) out/$(BUILDTYPE)/obj.target -name "*.gcda" -type f | xargs $(RM); \
	fi
	-NODE_V8_COVERAGE=coverage/tmp \
		TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) $(COVTESTS)
	$(MAKE) coverage-report-js
	-(PYTHONPATH=./gcovr $(PYTHON) -m gcovr \
		--object-directory=out \
		--filter src -v \
		--root ./ \
		--html --html-details -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	@printf "Javascript coverage %%: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@printf "C++ coverage %%: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

.PHONY: coverage-report-js
coverage-report-js:
	-$(MAKE) coverage-build-js
	$(NODE) ./node_modules/.bin/c8 report

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)
	$(NODE) ./test/embedding/test-embedding.js

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	export PATH="$(NO_BIN_OVERRIDE_PATH)" && \
		tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-js-native-api-tests build-node-api-tests ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		$(TEST_CI_ARGS) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(JS_SUITES) \
		$(NATIVE_SUITES)

.PHONY: tooltest
tooltest:
	@$(PYTHON) -m unittest discover -s ./test/tools

.PHONY: coverage-run-js
coverage-run-js:
	$(RM) -r coverage/tmp
	-NODE_V8_COVERAGE=coverage/tmp CI_SKIP_TESTS=$(COV_SKIP_TESTS) \
					TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) jstest
	$(MAKE) coverage-report-js

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s tooltest
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-js-native-api-tests
	$(MAKE) -s build-node-api-tests
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	$(MAKE) jstest
	$(MAKE) tooltest

# Used by `make coverage-test`
.PHONY: test-cov
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	CI_SKIP_TESTS=$(COV_SKIP_TESTS) $(MAKE) jstest

.PHONY: test-valgrind
test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

.PHONY: test-check-deopts
test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.mjs doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif
ifeq ($(OSTYPE),os400)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

node_use_openssl = $(call available-node,"-p" \
			 "process.versions.openssl != undefined")
test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules

=== debian/changelog ===
nodejs (20.18.3+dfsg-1) unstable; urgency=medium

  * New upstream version 20.18.3+dfsg
  * Really SKIP test-watch-mode - can hang

 -- Jérémy Lal <kapouer@melix.org>  Mon, 10 Feb 2025 15:45:36 +0100

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 sse2-support [i386] <!nocheck>,
 armv6k-support [armel] <!nocheck>, vfpv2-support [armel] <!nocheck>,
 debhelper-compat (= 13),
 dh-buildinfo,
 bash-completion,
 dh-sequence-bash-completion,
 ca-certificates,
 curl <!nocheck>,
 gyp (>= 0.16.0~),
 jq,
 libbrotli-dev,
 libbrotli-dev:native,
 libc-ares-dev (>= 1.18.1~),
 libc-ares-dev:native,
 libhttp-parser-dev (>= 2.9.2~),
 libicu-dev (>= 70.1~),
 libicu-dev:native,
 libnghttp2-dev (>= 1.41.0~),
 libnghttp2-dev:native,
 libnghttp3-dev (>= 1.4.0~),
 libnghttp3-dev:native,
 libngtcp2-dev (>= 1.6.0~),
 libngtcp2-dev:native,
 libsimdjson-dev (>= 3.10.1~),
 libsimdjson-dev:native,
 libssl-dev (>= 1.1.1~),
 libssl-dev:native,
 libuv1-dev (>= 1.43.0~),
 libuv1-dev:native,
 node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
 openssl (>= 1.1.1~) <!nocheck>,
 pkgconf,
 pkg-js-tools (>= 0.8.2~) <!nocheck>,
 python3:native,
 python3-packaging,
 procps <!nocheck>,
 zlib1g-dev,
 zlib1g-dev:native,
Build-Depends-Indep:
 node-js-yaml (>= 4.1.0+dfsg+~4.0.5-6) <!nodoc>,
 node-marked (>= 4~) <!nodoc>,
 node-highlight.js <!nodoc>,
Standards-Version: 4.6.2
Homepage: https://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-20.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-20.x
Rules-Requires-Root: no

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 libnode115 (= ${binary:Version})
Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
Replaces: libv8-dev,
 nodejs-dev (<< 10.0.0~dfsg1-3)
Conflicts: libv8-dev (<= 3.14.5.8-11)
Provides: libv8-dev
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode115

Package: nodejs
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: allowed
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 node-corepack <!pkg.nodejs.nobuiltin>,
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 libnode115 (= ${binary:Version})
Recommends: ca-certificates,
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
 , libnode105
 , libnode108
 , libnode109
Conflicts: nodejs-legacy
Breaks: node-typescript-types (<< 20210110~)
 , node-babel-runtime (<< 7)
 , node-jest (<< 29~)
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
 , libnode108 (<< 19)
 , libnode109 (<< 19)
Provides: node-types-node (= ${types:Node})
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode115
Section: libs
Architecture: amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-minimatch (>= 9.0.3-5) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
Breaks: node-modern-syslog (<< 1.1.4-2),
 libnode64 (<< 10.24.1~),
 libnode72 (<< 13),
 libnode108 (<< 19),
 libnode109 (<<19)
Replaces: nodejs-legacy, libnode72, libnode83, libnode93, libnode108, libnode109
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: nodejs
Depends: ${misc:Depends}
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

builtins := /usr/share/nodejs/node

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^#define NODE_MODULE_VERSION [0-9]+/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armel armhf i386 mips64el mips64r6el loong64 ppc64 ppc64el riscv64 s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--verbose \
--without-npm \
--without-corepack \
--shared \
--shared-zlib \
--shared-cares \
--shared-ngtcp2 \
--shared-nghttp3 \
--shared-nghttp2 \
--shared-brotli \
--shared-libuv \
--shared-simdjson \
--shared-builtin-undici/undici-path=/usr/share/nodejs/undici/undici-fetch.js \
--shared-builtin-acorn-path=/usr/share/nodejs/acorn/dist/acorn.js \
--shared-builtin-acorn_walk-path=/usr/share/nodejs/acorn-walk/dist/walk.js \
--shared-builtin-cjs_module_lexer/lexer-path=/usr/share/nodejs/cjs-module-lexer/lexer.js \
--shared-builtin-cjs_module_lexer/dist/lexer-path=/usr/share/nodejs/cjs-module-lexer/dist/lexer.js \
--shared-builtin-minimatch-path=/usr/share/nodejs/minimatch/dist/cjs/index.bundle.js \
--shared-openssl \
--openssl-use-def-ca-store \
--with-intl=system-icu \
--prefix=/usr \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs" \
--dest-os=linux

ifneq ($(filter pkg.nodejs.nobuiltin,$(DEB_BUILD_PROFILES)),)
	DEB_CONFIGURE_EXTRA_FLAGS += --node-builtin-modules-path=$(builtins)
endif

# map HOST ARCH AND OS, and if unknown let upstream guess

destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter loong64,$(DEB_HOST_ARCH)),loong64))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter riscv64,$(DEB_HOST_ARCH)),riscv64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian armel version
# v8 supports armv6k (must be set explicitely) + vfpv2 (selected by default)
# armv6k is only not available on ARM1136JF-S r0p2, and available on r1p0.
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv2 --with-arm-version=6
CFLAGS += -march=armv6k -mfpu=vfpv2
CPPFLAGS += -march=armv6k -mfpu=vfpv2
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3-d16
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3-d16
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
DEB_MAKE_BUILD_TARGET = build

skipTests =
# tests require undici >= 6.5.0
skipTests := $(skipTests),parallel/test-eventsource
# tests using npm
skipTests := $(skipTests),parallel/test-npm-install
skipTests := $(skipTests),parallel/test-npm-version
skipTests := $(skipTests),parallel/test-release-npm
# tests using network
skipTests := $(skipTests),parallel/test-dns
skipTests := $(skipTests),parallel/test-net-connect-immediate-finish
skipTests := $(skipTests),parallel/test-net-better-error-messages-port-hostname
skipTests := $(skipTests),parallel/test-https-connect-address-family
skipTests := $(skipTests),parallel/test-tls-connect-address-family
skipTests := $(skipTests),parallel/test-dns-cancel-reverse-lookup
skipTests := $(skipTests),parallel/test-dns-resolveany-bad-ancount
# bad test
skipTests := $(skipTests),parallel/test-child-process-stdio-overlapped
# requires corepack
skipTests := $(skipTests),parallel/test-corepack-yarn-install
skipTests := $(skipTests),parallel/test-corepack-version
# fail on buildd
skipTests := $(skipTests),sequential/test-force-repl
skipTests := $(skipTests),sequential/test-performance
# hangs https://github.com/nodejs/node/issues/44898
skipTests := $(skipTests),sequential/test-watch-mode
skipTests := $(skipTests),sequential/test-watch-mode-inspect
# CVE-2024-22017 shared libuv cannot guarantee io_uring is disabled
skipTests := $(skipTests),parallel/test-process-uid-gid
skipTests := $(skipTests),parallel/test-process-initgroups
skipTests := $(skipTests),parallel/test-process-setgroups
skipTests := $(skipTests),parallel/test-process-euid-egid
# sea requires postject
skipTests := $(skipTests),parallel/test-single-executable-application
# loading of openssl for tests make this test fail
skipTests := $(skipTests),parallel/test-strace-openat-openssl
# Might fail on slow architectures
skipTests := $(skipTests),parallel/test-runner-output
skipTests := $(skipTests),sequential/test-tls-session-timeout
# https://bugs.debian.org/919588
# flaky on some user environments
skipTests := $(skipTests),parallel/test-net-listen-after-destroying-stdin
# fails when running with eatmydata
skipTests := $(skipTests),parallel/test-fs-error-messages
# need privileges
skipTests := $(skipTests),parallel/test-cluster-bind-privileged-port
skipTests := $(skipTests),parallel/test-cluster-shared-handle-bind-privileged-port
skipTests := $(skipTests),parallel/test-debugger-preserve-breaks
# issues on 32-bit archs
skipTests := $(skipTests),parallel/test-debugger-heap-profiler
skipTests := $(skipTests),parallel/test-fs-utimes
skipTests := $(skipTests),parallel/test-fs-utimes-y2K38
skipTests := $(skipTests),parallel/test-debug-args
# https://github.com/nodejs/node/issues/27611#issuecomment-613100468
skipTests := $(skipTests),sequential/test-cpu-prof-dir-absolute
# Flaky in build servers
skipTests := $(skipTests),parallel/test-process-config
skipTests := $(skipTests),parallel/test-regress-GH-746
skipTests := $(skipTests),parallel/test-stdout-close-unref
skipTests := $(skipTests),sequential/test-fs-watch
skipTests := $(skipTests),sequential/test-http2-session-timeout
skipTests := $(skipTests),sequential/test-debugger-preserve-breaks
skipTests := $(skipTests),sequential/test-debugger-exec-scope
skipTests := $(skipTests),sequential/test-worker-heapsnapshot-options
# flaky on buildd https://github.com/nodejs/node/issues/39655
skipTests := $(skipTests),parallel/test-cluster-primary-error
skipTests := $(skipTests),parallel/test-cluster-primary-kill

export HOME = $(CURDIR)/tmp
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
export NODE_TEST_NO_INTERNET = 1
# needed for tests to avoid "ee key too small" errors

=== debian/watch ===
version=4
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=auto,\
repacksuffix=+dfsg \
https://nodejs.org/dist v(20\.\d+\.\d+)/ group

# IMPORTANT: do NOT upgrade @types/node when target is debian/stable,
# it will break some debian packages, and some users packages too.

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=types-node,pgpmode=none" \
 https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(20\.\d+\.\d+)@ARCHIVE_EXT@ ignore

opts="component=ada,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%ada-$1$2%" \
 https://github.com/ada-url/ada/tags?after=v2.9.99 \
 (?:.*?/)?v?(2\.9\.\d+)@ARCHIVE_EXT@ ignore

## nodejs 20.19.0+dfsg

=== debian/changelog ===
nodejs (20.19.0+dfsg-2) unstable; urgency=medium

  * Tests: two more profiler tests are flaky on loongson
  * Rephrase nodejs.README.Debian
  * Patch test for compatibility with openssl 3.5. Closes: #1101074.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 03 Apr 2025 23:21:02 +0200

nodejs (20.19.0+dfsg-1) unstable; urgency=medium

  * New upstream version 20.19.0+dfsg
  * mipsel has been unsupported by v8 for a long time,
    drop the patches.
  * Instead of using patches for configuring tests,
    patch test.py to support flaky tests set from d/rules
  * Drop cctest_disable.patch, was a no-op
  * Drop upstream-applied patches
  * copyright: drop non-matching files
  * Fix some DEP-3 fields in patches
  * Standards-Version 4.7.2, no changes.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 14 Mar 2025 00:27:43 +0100

=== debian/rules ===
--- 
+++ 
@@ -113,78 +113,87 @@
 endif
 
 DEB_DESTDIR = $(CURDIR)/debian/tmp
-DEB_MAKE_CLEAN_TARGET = clean
-DEB_MAKE_BUILD_TARGET = build
 
-skipTests =
-# tests require undici >= 6.5.0
-skipTests := $(skipTests),parallel/test-eventsource
 # tests using npm
-skipTests := $(skipTests),parallel/test-npm-install
-skipTests := $(skipTests),parallel/test-npm-version
-skipTests := $(skipTests),parallel/test-release-npm
+skipTests += parallel/test-npm-install
+skipTests += parallel/test-npm-version
+skipTests += parallel/test-release-npm
 # tests using network
-skipTests := $(skipTests),parallel/test-dns
-skipTests := $(skipTests),parallel/test-net-connect-immediate-finish
-skipTests := $(skipTests),parallel/test-net-better-error-messages-port-hostname
-skipTests := $(skipTests),parallel/test-https-connect-address-family
-skipTests := $(skipTests),parallel/test-tls-connect-address-family
-skipTests := $(skipTests),parallel/test-dns-cancel-reverse-lookup
-skipTests := $(skipTests),parallel/test-dns-resolveany-bad-ancount
+skipTests += parallel/test-dns
+skipTests += parallel/test-net-connect-immediate-finish
+skipTests += parallel/test-net-better-error-messages-port-hostname
+skipTests += parallel/test-https-connect-address-family
+skipTests += parallel/test-tls-connect-address-family
+skipTests += parallel/test-dns-cancel-reverse-lookup
+skipTests += parallel/test-dns-resolveany-bad-ancount
 # bad test
-skipTests := $(skipTests),parallel/test-child-process-stdio-overlapped
+skipTests += parallel/test-child-process-stdio-overlapped
 # requires corepack
-skipTests := $(skipTests),parallel/test-corepack-yarn-install
-skipTests := $(skipTests),parallel/test-corepack-version
+skipTests += parallel/test-corepack-yarn-install
+skipTests += parallel/test-corepack-version
 # fail on buildd
-skipTests := $(skipTests),sequential/test-force-repl
-skipTests := $(skipTests),sequential/test-performance
+skipTests += sequential/test-force-repl
+skipTests += sequential/test-performance
 # hangs https://github.com/nodejs/node/issues/44898
-skipTests := $(skipTests),sequential/test-watch-mode
-skipTests := $(skipTests),sequential/test-watch-mode-inspect
+skipTests += sequential/test-watch-mode
+skipTests += sequential/test-watch-mode-inspect
 # CVE-2024-22017 shared libuv cannot guarantee io_uring is disabled
-skipTests := $(skipTests),parallel/test-process-uid-gid
-skipTests := $(skipTests),parallel/test-process-initgroups
-skipTests := $(skipTests),parallel/test-process-setgroups
-skipTests := $(skipTests),parallel/test-process-euid-egid
+skipTests += parallel/test-process-uid-gid
+skipTests += parallel/test-process-initgroups
+skipTests += parallel/test-process-setgroups
+skipTests += parallel/test-process-euid-egid
 # sea requires postject
-skipTests := $(skipTests),parallel/test-single-executable-application
+skipTests += parallel/test-single-executable-application
 # loading of openssl for tests make this test fail
-skipTests := $(skipTests),parallel/test-strace-openat-openssl
+skipTests += parallel/test-strace-openat-openssl
 # Might fail on slow architectures
-skipTests := $(skipTests),parallel/test-runner-output
-skipTests := $(skipTests),sequential/test-tls-session-timeout
+flakyTests += parallel/test-runner-output
+flakyTests += sequential/test-tls-session-timeout
 # https://bugs.debian.org/919588
 # flaky on some user environments
-skipTests := $(skipTests),parallel/test-net-listen-after-destroying-stdin
+flakyTests += parallel/test-net-listen-after-destroying-stdin
 # fails when running with eatmydata
-skipTests := $(skipTests),parallel/test-fs-error-messages
+skipTests += parallel/test-fs-error-messages
 # need privileges
-skipTests := $(skipTests),parallel/test-cluster-bind-privileged-port
-skipTests := $(skipTests),parallel/test-cluster-shared-handle-bind-privileged-port
-skipTests := $(skipTests),parallel/test-debugger-preserve-breaks
+skipTests += parallel/test-cluster-bind-privileged-port
+skipTests += parallel/test-cluster-shared-handle-bind-privileged-port
+skipTests += parallel/test-debugger-preserve-breaks
 # issues on 32-bit archs
-skipTests := $(skipTests),parallel/test-debugger-heap-profiler
-skipTests := $(skipTests),parallel/test-fs-utimes
-skipTests := $(skipTests),parallel/test-fs-utimes-y2K38
-skipTests := $(skipTests),parallel/test-debug-args
+skipTests += parallel/test-debugger-heap-profiler
+skipTests += parallel/test-fs-utimes
+skipTests += parallel/test-fs-utimes-y2K38
+skipTests += parallel/test-debug-args
 # https://github.com/nodejs/node/issues/27611#issuecomment-613100468
-skipTests := $(skipTests),sequential/test-cpu-prof-dir-absolute
+skipTests += sequential/test-cpu-prof-dir-absolute
 # Flaky in build servers
-skipTests := $(skipTests),parallel/test-process-config
-skipTests := $(skipTests),parallel/test-regress-GH-746
-skipTests := $(skipTests),parallel/test-stdout-close-unref
-skipTests := $(skipTests),sequential/test-fs-watch
-skipTests := $(skipTests),sequential/test-http2-session-timeout
-skipTests := $(skipTests),sequential/test-debugger-preserve-breaks
-skipTests := $(skipTests),sequential/test-debugger-exec-scope
-skipTests := $(skipTests),sequential/test-worker-heapsnapshot-options
+flakyTests += parallel/test-process-config
+flakyTests += parallel/test-regress-GH-746
+flakyTests += parallel/test-stdout-close-unref
+flakyTests += sequential/test-fs-watch
+flakyTests += sequential/test-http2-session-timeout
+flakyTests += sequential/test-debugger-preserve-breaks
+flakyTests += sequential/test-debugger-exec-scope
+flakyTests += sequential/test-worker-heapsnapshot-options
 # flaky on buildd https://github.com/nodejs/node/issues/39655
-skipTests := $(skipTests),parallel/test-cluster-primary-error
-skipTests := $(skipTests),parallel/test-cluster-primary-kill
+flakyTests += parallel/test-cluster-primary-error
+flakyTests += parallel/test-cluster-primary-kill
 
-export HOME = $(CURDIR)/tmp
-export CI_JS_SUITES = message parallel sequential
-export NODE_TEST_DIR = $(CURDIR)/tmp
-export NODE_TEST_NO_INTERNET = 1
-# needed for tests to avoid "ee key too small" errors
+ifeq ($(DEB_HOST_ARCH), riscv64)
+flakyTests += sequential/test-diagnostic-dir-cpu-prof
+flakyTests += sequential/test-cpu-prof-worker-argv
+flakyTests += sequential/test-cpu-prof-dir-and-name
+flakyTests += sequential/test-cpu-prof-exit
+flakyTests += sequential/test-cpu-prof-kill
+flakyTests += sequential/test-cpu-prof-name
+flakyTests += sequential/test-diagnostic-dir-cpu-prof
+flakyTests += sequential/test-debugger-auto-resume
+flakyTests += sequential/test-debugger-preserve-breaks
+flakyTests += sequential/test-cpu-prof-dir-relative
+flakyTests += sequential/test-cpu-prof-drained
+flakyTests += sequential/test-worker-prof
+flakyTests += sequential/test-vm-timeout-escape-promise-module-2
+flakyTests += sequential/test-cpu-prof-dir-absolute
+flakyTests += parallel/test-fetch
+flakyTests += parallel/test-net-socket-connect-without-cb
+flakyTests += parallel/test-runner-inspect
+flakyTests += parallel/test-runner-output

## nodejs 20.19.0+dfsg1

=== debian/changelog ===
nodejs (20.19.0+dfsg1-1) unstable; urgency=medium

  * New repackaged upstream tarball includes deps/uv. 
  * Add missing changelogs to nodejs-doc
  * Lintian: old-fsf-address-in-copyright-file
  * watch: fix ada url to actually get current version
  * copyright: document deps/uv
  * Build bundled libuv on i386 architecture to fix CVE-2025-47153.
    Closes: #922075, #1076350,

 -- Jérémy Lal <kapouer@melix.org>  Thu, 01 May 2025 11:09:56 +0200

=== debian/watch ===
--- 
+++ 
@@ -2,7 +2,7 @@
 opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
 filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
 dversionmangle=auto,\
-repacksuffix=+dfsg \
+repacksuffix=+dfsg1 \
 https://nodejs.org/dist v(20\.\d+\.\d+)/ group
 
 # IMPORTANT: do NOT upgrade @types/node when target is debian/stable,
@@ -14,6 +14,6 @@
  https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(20\.\d+\.\d+)@ARCHIVE_EXT@ ignore
 
 opts="component=ada,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%ada-$1$2%" \
- https://github.com/ada-url/ada/tags?after=v2.9.99 \
+ https://github.com/ada-url/ada/tags?after=v3.0.0 \
  (?:.*?/)?v?(2\.9\.\d+)@ARCHIVE_EXT@ ignore
